#ifndef _EXAMPLE_FILE_NAME_H    /* Guard against multiple inclusion */
#define _EXAMPLE_FILE_NAME_H


/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdlib.h>

/* Provide C++ Compatibility */
#ifdef __cplusplus
extern "C" {
#endif

// *****************************************************************************
// *****************************************************************************
// Section: Type Definitions
// *****************************************************************************
// *****************************************************************************
    
/* Address of slave devices */
#define M6955_ADDRESS              0x10
#define AM  0b10000000
#define FM  0b11000000
    
    
typedef enum{
    INIT_OPEN = 0,    
    INIT_REG00,
    INIT_REG06,
    INIT_REG07,
    INIT_REG09,
    INIT_COMPLETED,
    INIT_ERROR            
}M6955_INIT_STATES;

typedef enum{
    
    FREQ_REG03 = 0,
    FREQ_REG02,
    FREQ_REG01_1,
    FREQ_REG01_2,
    FREQ_REG01_3,            
    FREQ_COMPLETED
            
}M6955_FREQ_STATES;
    
bool M6955_Init(void);
bool M6955_Freq(uint8_t, uint16_t);

    /* Provide C++ Compatibility */
#ifdef __cplusplus
}
#endif

#endif /* _EXAMPLE_FILE_NAME_H */

/* *****************************************************************************
 End of File
 */
